| Linduino 1.3.0 Linear Technology Arduino-Compatible Demonstration Board

LT_SPI.h File Reference
Linduino: Linear Technology Arduino-Compatible Demonstration Board Support Libraries » LT_SPI: Routines to communicate with ATmega328P's hardware SPI port.

LT_SPI: Routines to communicate with ATmega328P's hardware SPI port. More...

## Detailed Description

LT_SPI: Routines to communicate with ATmega328P's hardware SPI port.

Copyright 2018(c) Analog Devices, Inc.

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of Analog Devices, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
- The use of this software may or may not infringe the patent rights of one or more patent holders. This license does not release you from the requirement that you obtain separate licenses from these patent holders to use this software.
- Use of the software either in source or binary form, must be run on or directly connected to an Analog Devices Inc. component.

THIS SOFTWARE IS PROVIDED BY ANALOG DEVICES "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ANALOG DEVICES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, INTELLECTUAL PROPERTY RIGHTS, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Library Header File for LT_SPI: Routines to communicate with ATmega328P's hardware SPI port.

Definition in file LT_SPI.h.

Go to the source code of this file.

## Functions
void | spi_transfer_byte (uint8_t cs_pin, uint8_t tx, uint8_t *rx)
| Reads and sends a byte. More...
void | spi_transfer_word (uint8_t cs_pin, uint16_t tx, uint16_t *rx)
| Reads and sends a word. More...
void | spi_transfer_block (uint8_t cs_pin, uint8_t *tx, uint8_t *rx, uint8_t length)
| Reads and sends a byte array. More...
void | quikeval_SPI_connect ()
| Connect SPI pins to QuikEval connector through the Linduino MUX. This will disconnect I2C. More...
void | quikeval_SPI_init ()
| Configure the SPI port for 4Mhz SCK. More...
void | spi_enable (uint8_t spi_clock_divider)
| Setup the processor for hardware SPI communication. More...
void | spi_disable ()
| Disable the SPI hardware port. More...
void | spi_write (int8_t data)
| Write a data byte using the SPI hardware. More...
int8_t | spi_read (int8_t data)
| Read and write a data byte using the SPI hardware. More...

## Function Documentation

## ◆ quikeval_SPI_connect()

void quikeval_SPI_connect | ( |  | ) |

Connect SPI pins to QuikEval connector through the Linduino MUX. This will disconnect I2C.

Definition at line 138 of file LT_SPI.cpp.

## ◆ quikeval_SPI_init()

void quikeval_SPI_init | ( |  | ) |

Configure the SPI port for 4Mhz SCK.

This function or spi_enable() must be called before using the other SPI routines.

Definition at line 151 of file LT_SPI.cpp.

## ◆ spi_disable()

void spi_disable | ( |  | ) |

Disable the SPI hardware port.

Definition at line 170 of file LT_SPI.cpp.

## ◆ spi_enable()

void spi_enable | ( | uint8_t | spi_clock_divider | ) |

Setup the processor for hardware SPI communication.

Must be called before using the other SPI routines. Alternatively, call quikeval_SPI_connect(), which automatically calls this function.

Parameters

  spi_clock_divider | Configures SCK frequency. Use constant defined in header file.

Definition at line 160 of file LT_SPI.cpp.

## ◆ spi_read()

int8_t spi_read | ( | int8_t | data | ) |

Read and write a data byte using the SPI hardware.

Returns
  the data byte read

Read and write a data byte using the SPI hardware.

Parameters

  data | The data byte to be written

Definition at line 189 of file LT_SPI.cpp.

## ◆ spi_transfer_block()

void spi_transfer_block | ( | uint8_t | cs_pin,
|  | uint8_t * | tx,
|  | uint8_t * | rx,
|  | uint8_t | length
| ) |  |

Reads and sends a byte array.

Returns
  void

Parameters

  cs_pin | Chip select pin
  tx | Byte array to be transmitted
  rx | Byte array to be received
  length | Length of array

Definition at line 125 of file LT_SPI.cpp.

## ◆ spi_transfer_byte()

void spi_transfer_byte | ( | uint8_t | cs_pin,
|  | uint8_t | tx,
|  | uint8_t * | rx
| ) |  |

Reads and sends a byte.

Returns
  void

Parameters

  cs_pin | Chip select pin
  tx | Byte to be transmitted
  rx | Byte to be received

Definition at line 87 of file LT_SPI.cpp.

## ◆ spi_transfer_word()

void spi_transfer_word | ( | uint8_t | cs_pin,
|  | uint16_t | tx,
|  | uint16_t * | rx
| ) |  |

Reads and sends a word.

Returns
  void

Parameters

  cs_pin | Chip select pin
  tx | Byte to be transmitted
  rx | Byte to be received

Definition at line 98 of file LT_SPI.cpp.

## ◆ spi_write()

void spi_write | ( | int8_t | data | ) |

Write a data byte using the SPI hardware.

Parameters

  data | Byte to be written to SPI port

Definition at line 176 of file LT_SPI.cpp.